/*
  close.c - Stop Crazy Minigolf crashing on close.

  Jason Hood, 1 July, 2006.

  Crazy Minigolf crashes on close.  This appears to be due to FMOD freeing its
  samples when it closes, which Crazy then does as well.  This patch will skip
  the additional freeing.
*/

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <io.h>

int main( void )
{
  unsigned char one, two;
  HANDLE h;
  FILETIME ft1, ft2, ft3;

  FILE* file = fopen( "Crazy Minigolf.exe", "rb+" );
  if (file == NULL)
  {
    puts( "Please run this program in the same directory as \"Crazy Minigolf\"." );
    return 0;
  }
  h = (HANDLE)_get_osfhandle( fileno( file ) );
  GetFileTime( h, &ft1, &ft2, &ft3 );
  fseek( file, 0x816E, SEEK_SET );
  one = getc( file );
  two = getc( file );
  if (one == 0x8B && two == 0x56)
  {
    fseek( file, -2, SEEK_CUR );
    putc( 0xEB, file );
    putc( 0x16, file );
    SetFileTime( h, &ft1, &ft2, &ft3 );
    fclose( file );
    puts( "Patched!" );
    return 0;
  }
  else if (one == 0xEB && two == 0x16)
  {
    fseek( file, -2, SEEK_CUR );
    putc( 0x8B, file );
    putc( 0x56, file );
    SetFileTime( h, &ft1, &ft2, &ft3 );
    fclose( file );
    puts( "Restored!" );
    return 0;
  }
  else
  {
    puts( "Oops! looks like we have different versions." );
    fclose( file );
    return 1;
  }
}
